Index: CMT/v1r25-branch/source/cmt_symbol.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_symbol.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_symbol.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -15,4 +16,5 @@
 #include "cmt_database.h"
 #include "cmt_log.h"
+#include "cmt_error.h"
 
 // Global inhibitor of any display
@@ -42,4 +44,23 @@
   const cmt_string clean (const Symbol& symbol,
                           const cmt_string& tag_name = "");
+
+  void filter_path_value (const Symbol& symbol,
+			  cmt_string& value,
+			  const cmt_string& tag_name = "") const;
+  void filter_path_value (const Symbol& symbol,
+			  CmtSystem::cmt_string_vector& value,
+			  const cmt_string& tag_name = "") const;
+  inline const bool& get_strip_path () const;
+  inline void set_strip_path (const bool& strip_path);
+
+  static PathBuilder* get_path_builder ();
+
+private:
+  PathBuilder ();
+  PathBuilder (bool strip_path);
+  PathBuilder (const PathBuilder& other);
+  PathBuilder& operator = (const PathBuilder& other);
+
+  bool m_strip_path;
 };
 //-------------------------------------------------------------
@@ -248,4 +269,11 @@
 }
 
+//
+// Global cache
+//
+namespace
+{
+  cmt_vmap <cmt_string, cmt_string> cmdoutputs;
+}
 /**
 
@@ -285,4 +313,6 @@
   int start = 0;
 
+  //  static cmt_vmap <cmt_string, cmt_string> cmdoutputs;
+
   for (;;)
     {
@@ -337,24 +367,30 @@
             // to be applied. The output of the command is then substituted
 
+	  Symbol::all_set ();
+
           cmt_string result;
-
-          Symbol::all_set ();
-          CmtSystem::execute (command, result);
-          
-	  /*
-          int pos;
-          pos = result.find ('\n');
-          if (pos != cmt_string::npos) result.erase (pos);
-          pos = result.find ('\r');
-          if (pos != cmt_string::npos) result.erase (pos);
-	  */          
-	  process_cmd_output (result);
-
-          if (Cmt::get_debug ())
-            {
-              cout << "resolve_value: Executing [" << command << "] to expand a symbol value =>[" 
-                   << result << "]" << endl;
-            }
-          
+	  const cmt_string * presult;
+	  if (!(presult = cmdoutputs.find (command)))
+	    {
+	      CmtSystem::execute (command, result);
+	      
+	      process_cmd_output (result);
+	      cmdoutputs.add (command, result);
+	      if (Cmt::get_debug ())
+		{
+		  cout << "resolve_value: Executing [" << command << "] to expand a symbol value =>[" 
+		       << result << "]" << endl;
+		}
+	    }
+	  else
+	    {
+	      result = *presult;
+	      if (Cmt::get_debug ())
+		{
+		  cout << "resolve_value: Found in cache [" << command << "] to expand a symbol value =>[" 
+		       << result << "]" << endl;
+		}
+	    }
+
           text.replace_all (pattern, result);
 
@@ -378,14 +414,33 @@
           else
             {
+	      if (Cmt::get_env_access () ||
+		  Symbol::std_env_vars ().has (symbol_name))
+		{
                 // Symbol not found. Look for env. variable
               cmt_string value = CmtSystem::getenv (symbol_name);
-              
                 // When the env. variable is not defined, the replacement is empty
                 // thus all $(xxx) ${xxx} %xxx% patterns are always filtered away.
               text.replace_all (pattern, value);
               
+		  if (Cmt::get_debug ())
+		    {
+		      cerr << "resolve_value: getenv (" << symbol_name
+			   << ") => " << value << endl;
+		    }
                 // The substitution will restart from the same place
                 // allowing for recursive replacements
               start = begin;
+		}
+	      else
+		{
+		  if (Cmt::get_debug ())
+		    {
+		      cerr << "resolve_value: getenv (" << symbol_name
+			   << ") denied" << endl;
+		    }
+		  CmtError::set (CmtError::warning,
+				 "getenv (" + symbol_name + ") denied");
+		  return;
+		}
             }
         }
@@ -484,24 +539,30 @@
             // to be applied. The output of the command is substituted
 
+	  Symbol::all_set ();
+
           cmt_string result;
-
-          Symbol::all_set ();
-          CmtSystem::execute (command, result);
-          
-	  /*
-          int pos;
-          pos = result.find ('\n');
-          if (pos != cmt_string::npos) result.erase (pos);
-          pos = result.find ('\r');
-          if (pos != cmt_string::npos) result.erase (pos);
-	  */
-	  process_cmd_output (result);
-          
-          if (Cmt::get_debug ())
-            {
-              cout << "   Executing [" << command << "] to expand a macro value =>[" 
-                   << result << "]" << endl;
-            }
-          
+	  const cmt_string * presult;
+	  if (!(presult = cmdoutputs.find (command)))
+	    {
+	      CmtSystem::execute (command, result);
+	      
+	      process_cmd_output (result);
+	      cmdoutputs.add (command, result);
+	      if (Cmt::get_debug ())
+		{
+		  cout << "resolve_value_for_macros: Executing [" << command << "] to expand a symbol value =>[" 
+		       << result << "]" << endl;
+		}
+	    }
+	  else
+	    {
+	      result = *presult;
+	      if (Cmt::get_debug ())
+		{
+		  cout << "resolve_value_for_macros: Found in cache [" << command << "] to expand a symbol value =>[" 
+		       << result << "]" << endl;
+		}
+	    }
+
           text.replace_all (pattern, result);
 
@@ -621,24 +682,30 @@
             // to be applied. The output of the command is substituted
 
+	  Symbol::all_set ();
+
           cmt_string result;
-
-          Symbol::all_set ();
-          CmtSystem::execute (command, result);
-          
-	  /*
-          int pos;
-          pos = result.find ('\n');
-          if (pos != cmt_string::npos) result.erase (pos);
-          pos = result.find ('\r');
-          if (pos != cmt_string::npos) result.erase (pos);
-	  */          
-	  process_cmd_output (result);
-          
-          if (Cmt::get_debug ())
-            {
-              cout << "   Executing [" << command << "] to expand a macro value =>[" 
-                   << result << "]" << endl;
-            }
-          
+	  const cmt_string * presult;
+	  if (!(presult = cmdoutputs.find (command)))
+	    {
+	      CmtSystem::execute (command, result);
+	      
+	      process_cmd_output (result);
+	      cmdoutputs.add (command, result);
+	      if (Cmt::get_debug ())
+		{
+		  cout << "suppress_OS_delimiters: Executing [" << command << "] to expand a symbol value =>[" 
+		       << result << "]" << endl;
+		}
+	    }
+	  else
+	    {
+	      result = *presult;
+	      if (Cmt::get_debug ())
+		{
+		  cout << "suppress_OS_delimiters: Found in cache [" << command << "] to expand a symbol value =>[" 
+		       << result << "]" << endl;
+		}
+	    }
+
           text.replace_all (pattern, result);
 
@@ -692,5 +759,7 @@
 {
   static SetBuilder Set;
-  static PathBuilder Path;
+  static PathBuilder* PathPtr (PathBuilder::get_path_builder ());
+  //static PathBuilder Path (Cmt::get_strip_path ());
+  //static PathBuilder Path;
   static MacroBuilder Macro;
   static ScriptBuilder Script;
@@ -852,5 +921,6 @@
       break;
     case SymbolPath:
-      symbol.builder = &Path;
+      symbol.builder = PathPtr;
+      //symbol.builder = &Path;
       break;
     case SymbolAlias:
@@ -911,4 +981,28 @@
 
   return (SymbolMap);
+}
+
+//-------------------------------------------------------------
+Symbol::SymbolMap& Symbol::std_env_vars ()
+{
+  static SymbolMap env_vars;
+  static Symbol std_sym;
+  static bool initialized (false);
+  if (!initialized)
+    {
+      env_vars.add ("SITEROOT", std_sym);
+      env_vars.add ("CMTCONFIG", std_sym);
+      env_vars.add ("CMTBIN", std_sym);
+      env_vars.add ("CMTPATH", std_sym);
+      env_vars.add ("CMTHEADVERSION", std_sym);
+      env_vars.add ("CMTPROJECTPATH", std_sym);
+      env_vars.add ("CMTSITE", std_sym);
+      env_vars.add ("CMTEXTRATAGS", std_sym);
+      env_vars.add ("CMTSTRUCTURINGSTYLE", std_sym);
+      env_vars.add ("CMTHOME", std_sym);
+      env_vars.add ("CMTUSERCONTEXT", std_sym);
+      initialized = true;
+    }
+  return env_vars;
 }
 
@@ -1021,5 +1115,9 @@
             {
 	      if (use->get_strategy ("SetupRoot") &&
-		  use->get_package_name () != "cmt_standalone")
+		  use->get_package_name () != "cmt_standalone" &&
+		  (action_setup == Cmt::get_action () ||
+		   action_cleanup == Cmt::get_action ()) &&
+		  Requirements != Cmt::get_print_mode () &&
+		  Xml != Cmt::get_print_mode ())
 		{
 #ifdef WIN32
@@ -1084,5 +1182,5 @@
 	   */
 	  if (name == "constituents") return;
-	  if (name == "constituentscclean") return;
+	  if (name == "constituentsclean") return;
 
           if (use->get_current_scope () == ScopePrivate) return;
@@ -1165,4 +1263,26 @@
         }
     }
+}
+
+//-------------------------------------------------------------
+bool Symbol::set_strip_path (const bool& strip_path)
+{
+  PathBuilder::get_path_builder ()->set_strip_path (strip_path);
+  return true;
+  /*
+  // searching for a path symbol
+  for (int number = 0; number < Symbol::symbol_number (); number++)
+    {
+      Symbol& symbol = Symbol::symbol (number);
+      
+      if (symbol.type == Symbol::SymbolPath)
+	{
+	  static_cast<PathBuilder*> (symbol.builder)->set_strip_path (strip_path);
+	  return true;
+	}
+    }
+
+  return false;
+  */
 }
 
@@ -1422,4 +1542,6 @@
   cmt_string value;
 
+  if (Cmt::get_env_access ())
+    {
   for (number = 0; number < Symbol::symbol_number (); number++)
     {
@@ -1433,6 +1555,12 @@
 	  Symbol::expand (value);
 
+          if (Cmt::get_debug ())
+            {
+              cerr << "Symbol::all_set (set)> " << symbol.name << " = " << value << endl;
+            }
+
 	  CmtSystem::putenv (symbol.name, value);
 	}
+    }
     }
 
@@ -1500,4 +1628,8 @@
   }
 
+  static PathBuilder* pb (0);
+
+  if (Cmt::get_env_access ())
+    {
   for (number = 0; number < Symbol::symbol_number (); number++)
     {
@@ -1510,5 +1642,8 @@
 	{
 	  Symbol::expand (value);
-	  filter_path_value (symbol.name, value);
+	  if (!pb)
+	    pb = static_cast<PathBuilder*> (symbol.builder);
+	  pb->filter_path_value (symbol, value);
+	  //filter_path_value (symbol.name, value);
 
 #ifdef WIN32
@@ -1518,5 +1653,5 @@
           if (Cmt::get_debug ())
             {
-              cerr << "Symbol::all_set-2> " << symbol.name << " = " << value << endl;
+              cerr << "Symbol::all_set (path)> " << symbol.name << " = " << value << endl;
             }
 
@@ -1524,4 +1659,5 @@
 	}
     }
+    }
 
   running = false;
@@ -1529,5 +1665,6 @@
 
 //-------------------------------------------------------------
-void Symbol::all_print (PrintMode mode)
+void Symbol::all_print (PrintMode mode, ostream& out)
+//void Symbol::all_print (PrintMode mode)
 {
   static SymbolVector& Symbols = symbols ();
@@ -1550,5 +1687,5 @@
 	      (symbol.type == SymbolMacro))
 	    {
-	      if (symbol.print_macro (mode))
+	      if (symbol.print_macro (mode, out))
 		{
 		  //		  cout << endl;
@@ -1567,9 +1704,9 @@
 	      (symbol.type == SymbolPath))
 	    {
-	      if (symbol.print (mode))
+	      if (symbol.print (mode, out))
 		{
 		  if (mode == Bat)
 		    {
-		      cout << endl;
+		      out << endl;
 		    }
 		  else if (mode == Xml)
@@ -1579,5 +1716,5 @@
 		  else
 		    {
-		      cout << endl;
+		      out << endl;
 		    }
 		}
@@ -1593,4 +1730,6 @@
   static SymbolVector& Symbols = symbols ();
 
+  static PathBuilder* pb (0);
+
   int number;
 
@@ -1608,5 +1747,8 @@
 	  expand (temp);
 
-	  Symbol::filter_path_value (symbol.name, temp);
+	  if (!pb)
+	    pb = static_cast<PathBuilder*> (symbol.builder);
+	  pb->filter_path_value (symbol, temp);
+	  //Symbol::filter_path_value (symbol.name, temp);
         }
     }
@@ -1696,6 +1838,5 @@
             break;
           case Sh :
-	    cout << "[ -z ${" << name << "+CMT} ] || unset " << name;
-	  //            cout << "unset " << name;
+	    cout << "alias " << name << " >/dev/null 2>&1 && unalias " << name;
             result = 1;
             break;
@@ -1762,6 +1903,8 @@
 
 //-------------------------------------------------------------
-int Symbol::print (PrintMode mode)
-{
+int Symbol::print (PrintMode mode, ostream& out)
+{
+  static PathBuilder* pb (0);
+
   int result = 0;
 
@@ -1769,31 +1912,58 @@
   bool empty = (temp.size () == 0) ? true : false;
 
+  cmt_string _name (name);
+  switch (type)
+    {
+    case SymbolSet :
+    case SymbolPath :
+      expand (temp);
+      if (type == SymbolPath)
+	{
+	  if (!pb)
+	    pb = static_cast<PathBuilder*> (builder);
+	  pb->filter_path_value (*this, temp);
+	}
+      switch (mode)
+	{
+	case Xml :
+	  break;
+	default:
+	  if (0 != CmtSystem::mangle (name, _name))
+	    CmtMessage::info ("Replace " + name + " with " + _name);
+	  break;
+	}
+      break;
+    default:
+      break;
+    }
+
+  /*
   if (type == SymbolPath)
     {
       expand (temp);
-      Symbol::filter_path_value (name, temp);
-    }
-
-  cmt_string _name;
+      //Symbol::filter_path_value (name, temp);
+      if (!pb)
+	pb = static_cast<PathBuilder*> (builder);
+      pb->filter_path_value (*this, temp);
+    }
+  */
   switch (type)
     {
       case SymbolSet :
       case SymbolPath :
-	if (0 != CmtSystem::mangle (name, _name))
-	  CmtMessage::info ("Replace " + name + " with " + _name);
         switch (mode)
           {
             case Csh :
-              if (empty) cout << "unsetenv " << _name;
-              else cout << "setenv " << _name << " \"" << temp << "\"";
-              //else cout << "setenv " << name << " " << CmtSystem::quote (temp, " \t");
+              if (empty) out << "unsetenv " << _name;
+              else out << "setenv " << _name << " \"" << temp << "\"";
+              //else out << "setenv " << name << " " << CmtSystem::quote (temp, " \t");
 
               result = 1;
               break;
             case Sh :
-              if (empty) cout << "[ -z ${" << _name << "+CMT} ] || unset " << _name;
-	      //              if (empty) cout << "unset " << _name;
-              else cout << _name << "=\"" << temp << "\"; export " << _name;
-              //else cout << name << "=" << CmtSystem::quote (temp, " \t") << "; export " << name;
+              if (empty) out << "[ -z ${" << _name << "+CMT} ] || unset " << _name;
+	      //              if (empty) out << "unset " << _name;
+              else out << _name << "=\"" << temp << "\"; export " << _name;
+              //else out << name << "=" << CmtSystem::quote (temp, " \t") << "; export " << name;
 
               result = 1;
@@ -1801,10 +1971,10 @@
             case Bat :
               temp.replace_all ("/", "\\");
-              cout << "set " << _name << "=" << CmtSystem::quote (temp, " \t");
-              //cout << "set " << name << "=" << temp;
+              out << "set " << _name << "=" << CmtSystem::quote (temp, " \t");
+              //out << "set " << name << "=" << temp;
               result = 1;
               break;
             case Xml :
-              cout << "<variable><name>" << _name << "</name>"
+              out << "<variable><name>" << _name << "</name>"
 		   << "<value>" << temp << "</value></variable>";
               result = 1;
@@ -1816,5 +1986,5 @@
           {
             case Csh :
-              cout << "alias " << name <<
+              out << "alias " << name <<
 		" \"" << temp << "\"";
 	      //CmtSystem::quote (temp, " \t");
@@ -1822,5 +1992,5 @@
               break;
             case Sh :
-              cout << "alias " << name <<
+              out << "alias " << name <<
 		"=\"" << temp << "\"";
 	      //"=" << CmtSystem::quote (temp, " \t");
@@ -1828,5 +1998,5 @@
               break;
             case Bat :
-              cout << "set " << name <<
+              out << "set " << name <<
 		"=" << CmtSystem::quote (temp, " \t");
 	      //"=" << temp;
@@ -1834,5 +2004,5 @@
               break;
             case Xml :
-              cout << "<alias><name>" << name << "</name>"
+              out << "<alias><name>" << name << "</name>"
 		   << "<value>" << temp << "</value></alias>";
               result = 1;
@@ -1852,29 +2022,29 @@
               {
                 case Csh :
-                  cout << "if ( -f " << CmtSystem::quote (name, " \t") << ".csh ) then" << endl;
-                  cout << "  source " << CmtSystem::quote (name, " \t") << ".csh" << endl;
-                  cout <<
+                  out << "if ( -f " << CmtSystem::quote (name, " \t") << ".csh ) then" << endl;
+                  out << "  source " << CmtSystem::quote (name, " \t") << ".csh" << endl;
+                  out <<
 		    "if ( $status != 0 ) then\n"
 		    "    set cmtsetupstatus=1\n"
 		    "endif\n";
-                  cout << "endif" << endl;
+                  out << "endif" << endl;
                   result = 1;
                   break;
                 case Sh :
-                  cout << "if test -f " << CmtSystem::quote (name, " \t") << ".sh; then" << endl;
-                  cout << "  . " << CmtSystem::quote (name, " \t") << ".sh" << endl;
-                  cout <<
+                  out << "if test -f " << CmtSystem::quote (name, " \t") << ".sh; then" << endl;
+                  out << "  . " << CmtSystem::quote (name, " \t") << ".sh" << endl;
+                  out <<
 		    "if test $? != 0; then\n"
 		    "    cmtsetupstatus=1\n"
 		    "fi\n";
-                  cout << "fi" << endl;
+                  out << "fi" << endl;
                   result = 1;
                   break;
                 case Bat :
-                  cout << "call " << CmtSystem::quote (name, " \t");
+                  out << "call " << CmtSystem::quote (name, " \t");
                   result = 1;
                   break;
                 case Xml :
-                  cout << "<script>" << name << "</script>";
+                  out << "<script>" << name << "</script>";
                   result = 1;
                   break;
@@ -2124,5 +2294,5 @@
       SymbolValue& value = value_list.values[selected];
 
-      result += value_list.print (symbol, value, first_definition);
+      result += value_list.print (symbol, value, first_definition, out);
     }
 
@@ -2202,5 +2372,25 @@
             else if (temp == "")
               {
-                temp = CmtSystem::getenv (symbol.name);
+		if (Cmt::get_env_access () ||
+		    Symbol::std_env_vars ().has (symbol.name))
+		  {
+		    temp = CmtSystem::getenv (symbol.name);
+		    if (Cmt::get_debug ())
+		      {
+			cerr << "SetBuilder::build> getenv (" << symbol.name
+			     << ") => " << temp << endl;
+		      }
+		  }
+		else
+		  {
+		    if (Cmt::get_debug ())
+		      {
+			cerr << "SetBuilder::build> getenv (" << symbol.name
+			     << ") denied" << endl;
+		      }
+		    CmtError::set (CmtError::warning,
+				   "getenv (" + symbol.name + ") denied");
+		    return "";
+		  }
               }
 
@@ -2263,10 +2453,109 @@
 }
 
+namespace
+{
+int find_path_entry (const CmtSystem::cmt_string_vector& items, const cmt_string& value)
+{
+  //  if (value.size () == 0) return true;
+  
+  static cmt_vmap <cmt_string, cmt_string> realpaths;
+
+  cmt_string rvalue;
+  const cmt_string * prvalue;
+
+  if (!(prvalue = realpaths.find (value)))
+    {
+      // if (!CmtSystem::realpath_ (value, rvalue))
+      //{
+	  rvalue = value;
+	  CmtSystem::compress_path (rvalue);
+      //}
+      prvalue = &rvalue;
+      realpaths.add (value, rvalue);
+      //      cerr << "realpaths.add: " << value << " , " << rvalue << endl;
+    }
+
+  for (int i = 0; i < items.size (); i++)
+    {
+      const cmt_string& item = items[i];
+      if (item.size () == 0) continue;
+      cmt_string ritem;
+      const cmt_string * pritem;
+
+      if (!(pritem = realpaths.find (item)))
+	{
+	  //if (!CmtSystem::realpath_ (item, ritem))
+	  //{
+	      ritem = item;
+	      CmtSystem::compress_path (ritem);
+	  //}
+	  pritem = &ritem;
+	  realpaths.add (item, ritem);
+	  //  cerr << "realpaths.add: " << item << " , " << ritem << endl;
+	}
+      if (*pritem == *prvalue)
+	{
+	  return i;
+	}
+    }
+
+  return -1;
+}
+
+}
+/*
 static bool find_path_entry (const CmtSystem::cmt_string_vector& items, const cmt_string& value)
+{
+  if (value.size () == 0) return true;
+
+  static cmt_vmap <cmt_string, cmt_string> realpaths;
+
+  cmt_string rvalue;
+  const cmt_string * prvalue;
+
+  if (!(prvalue = realpaths.find (value)))
+    {
+      // if (!CmtSystem::realpath_ (value, rvalue))
+      //{
+	  rvalue = value;
+	  CmtSystem::compress_path (rvalue);
+      //}
+      prvalue = &rvalue;
+      realpaths.add (value, rvalue);
+      //      cerr << "realpaths.add: " << value << " , " << rvalue << endl;
+    }
+
+  for (int i = 0; i < items.size (); i++)
+    {
+      const cmt_string& item = items[i];
+      if (item.size () == 0) continue;
+      cmt_string ritem;
+      const cmt_string * pritem;
+
+      if (!(pritem = realpaths.find (item)))
+	{
+	  //if (!CmtSystem::realpath_ (item, ritem))
+	  //{
+	      ritem = item;
+	      CmtSystem::compress_path (ritem);
+	  //}
+	  pritem = &ritem;
+	  realpaths.add (item, ritem);
+	  //  cerr << "realpaths.add: " << item << " , " << ritem << endl;
+	}
+      if (*pritem == *prvalue)
+	{
+	  return true;
+	}
+    }
+
+  return false;
+}
+*/
+/*
+static bool find_path_entry (const cmt_string& paths, const cmt_string& value)
 {
   static const cmt_string path_separator = CmtSystem::path_separator ();
   static cmt_vmap <cmt_string, cmt_string> realpaths;
-
-  if (value.size () == 0) return true;
 
   cmt_string rvalue;
@@ -2285,6 +2574,6 @@
     }
 
-  //  CmtSystem::cmt_string_vector items;
-  //  CmtSystem::split (paths, path_separator, items);
+  CmtSystem::cmt_string_vector items;
+  CmtSystem::split (paths, path_separator, items);
 
   bool found = false;
@@ -2293,5 +2582,4 @@
     {
       const cmt_string& item = items[i];
-      if (item.size () == 0) continue;
       cmt_string ritem;
       const cmt_string * pritem;
@@ -2317,55 +2605,23 @@
   return (found);
 }
-
-static bool find_path_entry (const cmt_string& paths, const cmt_string& value)
-{
-  static const cmt_string path_separator = CmtSystem::path_separator ();
-  static cmt_vmap <cmt_string, cmt_string> realpaths;
-
-  cmt_string rvalue;
-  const cmt_string * prvalue;
-
-  if (!(prvalue = realpaths.find (value)))
-    {
-      if (!CmtSystem::realpath_ (value, rvalue))
-	{
-	  rvalue = value;
-	  CmtSystem::compress_path (rvalue);
-	}
-      prvalue = &rvalue;
-      realpaths.add (value, rvalue);
-      //      cerr << "realpaths.add: " << value << " , " << rvalue << endl;
-    }
-
-  CmtSystem::cmt_string_vector items;
-  CmtSystem::split (paths, path_separator, items);
-
-  bool found = false;
-
-  for (int i = 0; i < items.size (); i++)
-    {
-      const cmt_string& item = items[i];
-      cmt_string ritem;
-      const cmt_string * pritem;
-
-      if (!(pritem = realpaths.find (item)))
-	{
-	  if (!CmtSystem::realpath_ (item, ritem))
-	    {
-	      ritem = item;
-	      CmtSystem::compress_path (ritem);
-	    }
-	  pritem = &ritem;
-	  realpaths.add (item, ritem);
-	  //  cerr << "realpaths.add: " << item << " , " << ritem << endl;
-	}
-      if (*pritem == *prvalue)
-	{
-	  found = true;
-	  break;
-	}
-    }
-
-  return (found);
+*/
+//-------------------------------------------------------------
+PathBuilder* PathBuilder::get_path_builder ()
+{
+  static PathBuilder Path (Cmt::get_strip_path ());
+  return &Path;
+}
+
+//-------------------------------------------------------------
+PathBuilder::PathBuilder ()
+  : m_strip_path (false)
+{
+}
+
+//-------------------------------------------------------------
+PathBuilder::PathBuilder (bool strip_path)
+{
+  PathBuilder ();
+  m_strip_path = strip_path;
 }
 
@@ -2401,6 +2657,29 @@
   level++;
 
+		if (Cmt::get_env_access () ||
+		    Symbol::std_env_vars ().has (symbol.name))
+		  {
+  //temp = CmtSystem::getenv (symbol.name);
   CmtSystem::split (CmtSystem::getenv (symbol.name), path_separator, temp_vector);
-  //temp = CmtSystem::getenv (symbol.name);
+  filter_path_value (symbol, temp_vector);
+		    if (Cmt::get_debug ())
+		      {
+			cmt_string temp_txt;
+			Cmt::vector_to_string (temp_vector, path_separator, temp_txt);
+			cerr << "PathBuilder::build> getenv (" << symbol.name
+			     << ") => " << temp_txt << endl;
+		      }
+		  }
+		else
+		  {
+		    if (Cmt::get_debug ())
+		      {
+			cerr << "PathBuilder::build> getenv (" << symbol.name
+			     << ") denied" << endl;
+		      }
+		    CmtError::set (CmtError::warning,
+				   "getenv (" + symbol.name + ") denied");
+		    return "";
+		  }
 
   bool first_definition = true;
@@ -2442,4 +2721,5 @@
 		CmtSystem::split (new_value, path_separator, temp_vector);
                 //temp = new_value;
+		filter_path_value (symbol, temp_vector);
               }
 
@@ -2451,14 +2731,17 @@
 		CmtSystem::split (new_value, path_separator, new_value_vector);
 		for (int i = 0; i < new_value_vector.size (); i++)
-		  if (!find_path_entry (temp_vector, new_value_vector[i]))
-		    //if (!find_path_entry (temp, new_value))
-		    {
-		      temp_vector.push_back (new_value_vector[i]);
-		      /*
-			if (temp != "") temp += path_separator;
-			
-			temp += new_value;
-		      */
-		    }
+		  {
+		    if (new_value_vector[i].size () == 0) continue;
+		    int j = find_path_entry (temp_vector, new_value_vector[i]);
+		    if (j < 0)
+		      {
+			temp_vector.push_back (new_value_vector[i]);
+		      }
+		    else if (j < temp_vector.size () - 1)
+		      {
+			temp_vector [j] = "";
+			temp_vector.push_back (new_value_vector[i]);
+		      }
+		  }
               }
                   
@@ -2473,18 +2756,20 @@
 		for (int i = temp_vector.size () - 1; i > n - 1; i--)
 		  temp_vector [i] = temp_vector [i - n];
+		for (int i = 0; i < n; i++)
+		  temp_vector [i] = "";
 		for (int i = 0; i < new_value_vector.size (); i++)
-		  if (!find_path_entry (temp_vector, new_value_vector[i]))
-		    //if (!find_path_entry (temp, new_value))
-		    {
-		      temp_vector [i] = new_value_vector[i];
-		      /*
-			previous_temp = temp;
-			temp = new_value;
-			if (previous_temp != "") temp += path_separator;
-			temp += previous_temp;
-		      */
-		    }
-		  else
-		    temp_vector [i] = "";
+		  {
+		    if (new_value_vector[i].size () == 0) continue;
+		    int j = find_path_entry (temp_vector, new_value_vector[i]);
+		    if (j < 0)
+		      {
+			temp_vector [i] = new_value_vector[i];
+		      }
+		    else if (j >= n)
+		      {
+			temp_vector [i] = new_value_vector[i];
+			temp_vector [j] = "";
+		      }
+		  }
               }
 	    
@@ -2614,5 +2899,5 @@
 
   level--;
-
+  /*
   for (;;)
     {
@@ -2637,5 +2922,5 @@
   temp.replace_all ("::", ":");
   temp.replace_all (";;", ";");
-  
+  */
   return (temp);
 }
@@ -2767,4 +3052,90 @@
   
   return (temp);
+}
+
+//-------------------------------------------------------------
+void PathBuilder::filter_path_value (const Symbol& symbol,
+				     CmtSystem::cmt_string_vector& value,
+				     const cmt_string& /* tag_name */) const
+{
+  static cmt_regexp reg ("[$%`]");
+
+  cmt_vector<int> path (value.size ());
+  int n (0);
+
+  for (int j = 0; j < value.size (); j++)
+    {
+      const cmt_string& v = value[j];
+      bool exists (false);  
+      for (int i = 0; i < j; i++)
+	{
+          if (value[i] == v)
+	    {
+	      exists = true;
+	      break;
+	    }
+	}	  	  
+      if (!exists)
+	{
+	  if (m_strip_path)
+	    {
+	      if (!reg.match (v))
+		{
+		  if (!CmtSystem::test_directory (v))
+		    {
+		      CmtMessage::verbose ("Non-existent directory " + v + " in " + symbol.name + " skipped");
+		      continue;
+		    }
+		}
+	      else
+		{
+		  if (CmtMessage::active (Verbose))
+		    {
+		      CmtMessage::warning ("Unresolved directory name " + v + " in " + symbol.name);
+		    }
+		}
+	    }
+	  else
+	    {
+	      if (CmtMessage::active (Verbose))
+		if (!reg.match (v) &&
+		    !CmtSystem::test_directory (v))
+		  {
+		    CmtMessage::warning ("Non-existent directory " + v + " in " + symbol.name);
+		  }
+	    }
+	  path[n++] = j;
+	}
+    }
+
+  for (int i = 0; i < n; i++)
+    if (i != path[i]) value[i] = value[path[i]];
+  
+  value.resize (n);
+}
+
+//-------------------------------------------------------------
+void PathBuilder::filter_path_value (const Symbol& symbol,
+				     cmt_string& value,
+				     const cmt_string& tag_name) const
+{
+  static cmt_string ps (CmtSystem::path_separator ());
+  CmtSystem::cmt_string_vector paths;
+
+  CmtSystem::split (value, ps, paths);
+  filter_path_value (symbol, paths, tag_name);
+  Cmt::vector_to_string (paths, ps, value);
+}
+
+//-------------------------------------------------------------
+inline const bool& PathBuilder::get_strip_path () const
+{
+  return m_strip_path;
+}
+
+//-------------------------------------------------------------
+inline void PathBuilder::set_strip_path (const bool& strip_path)
+{
+  m_strip_path = strip_path;
 }
 
@@ -3275,13 +3646,15 @@
 int SymbolValueList::print (const Symbol& symbol, 
 			    const SymbolValue& value, 
-			    bool& first_definition) const
+			    bool& first_definition,
+			    ostream& out) const
 {
   int result (0);
-
-  //if (use->get_package_name () == "CMT") return result;
 
   cmt_string discarded_text;
   cmt_string define_text;
   ActionType action = Cmt::get_action ();
+
+  static PathBuilder* pb (0);
+  cmt_string rvalue (value.text);
 
   switch (command_type)
